// BallInfo.java

package objectP;

import genericP.*;
import java.awt.geom.*;

/********************************************************/
/*         BallInfo     ܡ                      */
/********************************************************/

public class BallInfo extends ObjectInfo{

/***************************************************************************/

  public BallInfo(){
    super(0,0);
    setDecay(Generic.BALL_DECAY);
    setCertainty(0.0);
    setRand(Generic.BALL_RAND);
    conf_decay = 0.8;
  }

/***************************************************************************/

  public BallInfo(double distance,double direction){
    super(distance, direction);
    setDecay(Generic.BALL_DECAY);
    setRand(Generic.BALL_RAND);conf_decay = 0.8;
  }

/***************************************************************************/

  public BallInfo(double distance,double direction,
		  double distanceChange,double directionChange){
    super(distance, direction, distanceChange, directionChange);
    setDecay(Generic.BALL_DECAY);
    setRand(Generic.BALL_RAND);conf_decay = 0.8;
  }

/***************************************************************************/

  public String toStringBallInfo(){  // sprintf
    StringBuffer strBuff = new StringBuffer("(NIT_ball ");
    strBuff.append(getTime()).append(" ").append(getX()).append(" ")
       .append(getY()).append(" ").append(getVX()).append(" ")
       .append(getVY()).append(" ").append(getAX()).append(" ")
       .append(getAY()).append(")");
    return strBuff.toString();
  }

/***************************************************************************/

  // 󥹥ȥ饯ǤϿʤΤϥޥΤ
  public void setBallInfo(int Time , double Dist , double Dir){
    controlTime = Time;
    seenTime = Time;
    dist = Dist;
    dir = Dir;
    
    /* Unknown Ƥ٤Ȼפ
    distChange = DistChng;
    dirChange = DirChng; 
    */

    setCertainty(1.0);
    setRand(Generic.BALL_RAND);
    setDecay(Generic.BALL_DECAY);
    conf_decay = 0.8;
  }

/***************************************************************************/

  // 󥹥ȥ饯ǤϿʤΤϥޥΤ
  public void setBallInfo(int Time , double Dist , double Dir , double DistChng , double DirChng){
    controlTime = Time;
    seenTime = Time;
    dist = Dist;
    dir = Dir;
    distChange = DistChng;
    dirChange = DirChng;

    setCertainty(1.0);
    setRand(Generic.BALL_RAND);
    setDecay(Generic.BALL_DECAY);
    conf_decay = 0.8;
  }

/***************************************************************************/

  public double getPredX(int t){     //  t Xɸͽ¬
    double predX = pos.getX();
    double predVX = vel.getX();
    
    for(int i = 0; i < t; i++){
	predX += predVX;
	predVX *= decay;
    }
    
    return predX;
  }

/***************************************************************************/

  public double getPredY(int t){     //  t Yɸͽ¬
    double predY = pos.getY();
    double predVY = vel.getY();
    
    for(int i = 0; i < t; i++){
	predY += predVY;
	predVY *= decay;
    }
    
    return predY;
  }

/***************************************************************************/

  public Point2D getPredPos(int t){   //  t κɸͽ¬
    Point2D temp = new Point2D.Double(getPredX(t) , getPredY(t));

    return temp;
  }

/***************************************************************************/

  // οʹ
  public void advanceBallInfo(int filedTime){
    if (filedTime == controlTime){
      // ʹԤɬפʤ
      return;
    }

    // Υγξڤ줿
    //RemoveNoise();
	
    double ux,uy; 
    // ¹Ԥɬ 1 äΤƤΤ
    if (getCertainty2()){
      ux = vel.getX() + acc.getX();
      uy = vel.getY() + acc.getY();

      pos.setLocation(pos.getX()+ux , pos.getY()+uy);
      
      vel.setLocation(ux * decay , uy * decay);

      acc.setLocation(0.0 , 0.0);

      certainty *= conf_decay;
      controlTime++;
    }
    
    // Ū 2 ðʾΥʤϤǰΰ
    while((filedTime - controlTime) != 0){
      // 2 ðʾΤξϤǽ
      if (getCertainty2()){
	// Ф˲®٤Ǥ뤫
	ux = vel.getX();
	uy = vel.getY();
	
	pos.setLocation(pos.getX()+ux , pos.getY()+uy);
	
	vel.setLocation(ux * decay , uy * decay);
	
	certainty *= conf_decay;	
      }
      controlTime++;
    }
  }

/***************************************************************************/

  // ǡ򥯥ꥢ롥˥ߤĤʤ褦ˤ١
  private void ClearBallInfo(){
    setPos(0.0,0.0);
    setV(0.0,0.0);
    setA(0.0,0.0);
    setCertainty(0.0);
   
    // Unknown ̻Ҥ줿̩Ȼפ
    dir = 0;
    dist = 0;
    distChange = 0;
    dirChange = 0; 
  }
  
/***************************************************************************/  

  // ܡ˴ؤƤǡξõɬפΤ,äȤ
  public boolean getCertainty2(){
    if (certainty < min_conf){
      ClearBallInfo();
      return false;
    }
    return true;
  }

/***************************************************************************/

  // see  sense Ʊ뤿
  public void adjustBallDir(double turnDir){
    dir -= turnDir;
  }
}









