#ifndef	   DEBUG_CLIENT_CONNECTION_H_INCLUDED
#define	   DEBUG_CLIENT_CONNECTION_H_INCLUDED

// Author:		H. Shimora
// Last-Modified:	May 25 2000
// Created:		May 25 2000
// Version:		0.00

///-----------------------------------------------
/// Change Log:
///-----------------------------------------------
// version 0.00  May 25 2000    base version.
//
//

#include  "udp_connection.h"
#include  "ip_address.h"
#include  "debug_server_connection.h"
#include  <string>

class  Debug_Client_Connection
{
public:
	static	const	long	DEFAULT_MAX_RESPONCE_TIME
						= 5 * 1000 * 1000; // 5 sec.

protected:
	UDP_Connection		udp;

protected:
	// Don't allow this.
	 Debug_Client_Connection( const Debug_Client_Connection & );
	// Don't allow this.
	 Debug_Client_Connection &
			 operator=( const Debug_Client_Connection & );

public:
		 Debug_Client_Connection( const std::string &  host
						 = "localhost" ,
					  ip_port_number_t  port
						 = Debug_Server_Connection
							  ::DEFAULT_PORT ,
					  long  max_response
						 = DEFAULT_MAX_RESPONCE_TIME );

	virtual	~Debug_Client_Connection();

	virtual	int		fd() const;


	virtual			operator bool() const;
	virtual	bool		responsive() const;

	virtual	int		send( const std::string &  str );

	virtual	bool		recv( std::string *  data ,
				      bool  block = false );

	virtual	bool		recv( std::string *  data ,  long  usec );
};

#endif	/* DEBUG_CLIENT_CONNECTION_H_INCLUDED */
